#include "../Headers/adc.h"

volatile enum ADC_state_t ADC_state;

void ADCInit()
{
    //AVCC reference
    cbi(ADMUX, REFS1);
    sbi(ADMUX, REFS0);

    //ADC1 input
    sbi(ADMUX, MUX0);
    ADC_state = potmeter;

    //Result is shifted to the left -> upper 8 bit in ADCRH
    sbi(ADMUX, ADLAR);
}

void ADCEnable()
{
    //prescaler 128
    sbi(ADCSRA, ADPS2);
    sbi(ADCSRA, ADPS1);
    sbi(ADCSRA, ADPS0);

    //Enabling interrupt
    sbi(ADCSRA, ADIE);

    //Enabling the AD converter
    sbi(ADCSRA, ADEN);
}


void ADCStart()
{
    sbi(ADCSRA, ADSC);
}

//Next AD channel
void NextCH()
{
    switch (ADC_state)
    {
    //On ADC1 pin is the potentiometer
    case potmeter:
        //The next pin is the ADC2, there is the NTC divider
        cbi(ADMUX, MUX0);
        sbi(ADMUX, MUX1);
        ADC_state = NTC;
        break;

    //On ADC2 pin is the NTC divider
    case NTC:
        //The next pin is the ADC1, there is the potentiometer
        cbi(ADMUX, MUX1);
        sbi(ADMUX, MUX0);
        ADC_state = potmeter;
        break;

    default:
        break;
    }
}