#include "../Headers/adc.h"

void ADCInit()
{
    //AVCC reference
    cbi(ADMUX, REFS1);
    sbi(ADMUX, REFS0);

    //ADC1 input
    sbi(ADMUX, MUX0);

    //Result is left-aligned -> upper 8 bit in ADCRH
    sbi(ADMUX, ADLAR);
}

void ADCEnable()
{
    //128x prescaler
    sbi(ADCSRA, ADPS2);
    sbi(ADCSRA, ADPS1);
    sbi(ADCSRA, ADPS0);

    //Interrupt enable
    sbi(ADCSRA, ADIE);

    //AD converter enable
    sbi(ADCSRA, ADEN);
}


void ADCStart()
{
    sbi(ADCSRA, ADSC);
}